function [] = disp(obj,U)

%harmonic amplitude diagram
H=obj.H;
Neq=obj.Neq;

Xtickstr=cell(1,H*2+1);
Xtickstr{1}='H0';
for ii=1:H
  Xtickstr{2*ii}=['H',num2str(ii),'c'];
  Xtickstr{2*ii+1}=['H',num2str(ii),'s'];
end
%Xtickstr
figure(4)
subplot(2,1,1)
bar(U(1:Neq:(2*H+1)*Neq));
title('Harmonic amplitude for u1')
set(gca,'XtickLabel',Xtickstr)

subplot(2,1,2);
bar(U(2:Neq:(2*H+1)*Neq+1));
title('Harmonic amplitude for u2')
set(gca,'XtickLabel',Xtickstr)


%Reconstruction du cycle limite
H=obj.H;
Neq=obj.Neq;
T=2*pi/U(end);
temps=0:0.001*T:T;

VectCos=zeros(H,length(temps));
VectSin=zeros(H,length(temps));
for j=1:H,
VectCos(j,:) = cos(j*U(end)*temps);
VectSin(j,:) = sin(j*U(end)*temps);
end;


cycle_u1= U(1) + U(Neq+1:2*Neq:(2*H-1)*Neq+1)'*VectCos + U(2*Neq+1:2*Neq:(2*H)*Neq+1)'*VectSin;
cycle_u2= U(2) + U(Neq+2:2*Neq:(2*H-1)*Neq+2)'*VectCos + U(2*Neq+2:2*Neq:(2*H)*Neq+2)'*VectSin;
cycle_v1= U(3) + U(Neq+3:2*Neq:(2*H-1)*Neq+3)'*VectCos + U(2*Neq+3:2*Neq:(2*H)*Neq+3)'*VectSin;
cycle_v2= U(4) + U(Neq+4:2*Neq:(2*H-1)*Neq+4)'*VectCos + U(2*Neq+4:2*Neq:(2*H)*Neq+4)'*VectSin;



% Comparaison with direct intergration
% X0 initial condition ; T period
X0=[ cycle_u1(1) cycle_u2(1) cycle_v1(1) cycle_v2(1)]
[temps_ode X] =ode45(@ressort,[0 T],X0); ;


hh=figure(3);set(hh,'Position',[1,1,1000,800]);
subplot(2,1,1)
plot(temps,cycle_u1,'b',temps,cycle_u2,'r',temps_ode,X(:,1),'.b',temps_ode,X(:,2),'.r');
title(['Time evolution of u1 and u_2 with ' num2str(H) ' harmonics'],'Fontsize',16)
xlabel('time (s)'):ylabel('ui');legend(['u1'],['u2'],['u1(ODE45)'],['u2(ODE45)'],'Location','SouthEast');grid on;

subplot(2,1,2);
plot(cycle_u1,cycle_u2,'b',X(:,1),X(:,2),'.b');
title(['Trajectory in the configuration space (u1,u2)'], 'FontSize',16);
xlabel('u1'):ylabel('u2');legend(['HBM'],['Num. Int. with ODE45'],'Location','SouthEast');grid on;axis equal


%plot(cycle_u,cycle_v,'b',cycle_u_ode(:,1),cycle_u_ode(:,2),'r');
%title(['Attractor in the phase space (u,v=u'')'], 'FontSize',16);
%xlabel('u'):ylabel('v=u''');legend(['Solution with ' num2str(H) ' harmonics'],['Solution from time domain ODE-solver'],'Location','SouthEast');grid on;


