COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %          EVE  Version Manlab   (B. Cochelin Avril 2005)         %
COMM %                                                                 %
COMM %           Origine : EVE   Version 2.1  (Novembre 94)            %                
COMM %                                                                 %
COMM %       //////  MODULE PILOTE DU CALCUL MAN  //////               %
COMM %                                                                 %
COMM %         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%             %
COMM %         %      METHODE ASYMPTOTIQUE_NUMERIQUE     %             %    
COMM %         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%             %
COMM %                                                                 %
COMM %        <<L(U),dU>> +  <<Q(U,U),dU>> = lbd <<F,du>>              %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       SUBROUTINE MAN(COOR,MAIL,EMAI,EPAI,LIAI,DFOR,DREL,ICO,
     *                IDIA,RIG,F,C0,U0,SIG0,Ci,Ui,SIGi,Ti,FQi,
     *                Ftra,Utra,Stra,RES,
     *                Nordre)      
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %   IDIA       Pointeurs de la diagonale       (ENTIER)           %
COMM %   RIG        Matrice de rigidite             (DP)               %
COMM %   F          Le vecteur de charge appliquee  (DP)               %
COMM %   C0         Parametre de charge initial     (DP)               %
COMM %   V0         Vecteur deplacement initial     (DP)               %
COMM %   SIG0       Vecteur contrainte initial      (DP)               %      
COMM %   Ci         Les coefficients aux ordres i   (DP)               %
COMM %   Vi         Les deplacements aux ordres i   (DP)               %
COMM %   SIGi       Les contraintes aux ordres i    (DP)               %
COMM %   Ti         Les gradients de Vi aux ordres i(DP)               %
COMM %   FQi        Les vecteurs FQ aux ordres i    (DP)               %  
COMM %   Ftra       vecteur de travail (NDL)        (DP)               %
COMM %   Utra       Vecteur de travail (NDL)        (DP)               % 
COMM %   Stra       Vecteur de travail (NSIG)       (DP)               %
COMM %   RES        Vecteur Residu     (NDL)        (DP)               % 
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      INTEGER          ICO(50)

      DOUBLE PRECISION COOR(*)
      INTEGER          MAIL(*)
      DOUBLE PRECISION EMAI(*)
      DOUBLE PRECISION EPAI(*)
      INTEGER          LIAI(*)
      REAL             DFOR(*)
      REAL             DREL(*)

      INTEGER          IDIA(*)
      DOUBLE PRECISION RIG(*)
      DOUBLE PRECISION F(*)
      DOUBLE PRECISION C0
      DOUBLE PRECISION U0(*)
      DOUBLE PRECISION SIG0(*)
      DOUBLE PRECISION Ci
      DOUBLE PRECISION Ui(*)
      DOUBLE PRECISION SIGi(*)      
      DOUBLE PRECISION Ti
      DOUBLE PRECISION FQi(*)
      DOUBLE PRECISION Ftra(*)       
      DOUBLE PRECISION Utra(*) 
      DOUBLE PRECISION Stra(*)            
      DOUBLE PRECISION RES(*)      

      DOUBLE PRECISION XL,CRIT,RAYON,LAMBDA,DA,A,XNORM1R,DELTA,DMU,
     *                 FNLNORM(100),RAPP,NORME1     
      LOGICAL APOSITIF
      
COMM .............../////  reprise des valeurs entires dans ICO  ///////............. 
     
      KTYP =ICO(1)
      NCPN =ICO(2)
      NDPN =ICO(3)
      NNPE =ICO(4)
      NSPG =ICO(5)            
      NNOE =ICO(6)
      NDL  =ICO(7)
      NMAI =ICO(8)
      NVMA =ICO(10)
      NLIAI=ICO(11)
      NVF1 =ICO(13)
      IF(KTYP.EQ.1.OR.KTYP.EQ.2.OR.KTYP.EQ.3) THEN ! Elasticite 2D
        NTPG=4
      ELSE IF(KTYP.EQ.4) THEN                      ! Elasticite 3D
        NTPG=9 
      ELSE IF(KTYP.EQ.5) THEN                      ! Coques 
        NTPG=2       
      ELSE
       STOP ' Pb KTYP ANMCA2 '
      ENDIF                        
COMM
COMM .....//// Profil de K, nombre de termes de K et de S ////......
COMM 

      CALL PROFBI(IDIA,MAIL,NDL,NMAI,NRIG,NNPE,NDPN,KTYP)
      ICO(26)=NRIG
      CALL LONSIG(MAIL,NMAI,NNPE,NSPG,NSIG,NEPS,KTYP)
      ICO(27)=NSIG
      NTET=(NSIG/NSPG)*NTPG              
COMM 
      WRITE(6,150)                      
COMM  
COMM  ...//// on initialise le point de demarrage  zero///..........
COMM
       C0=0.D0
       CALL DZERO(U0,NDL)
       CALL DZERO(SIG0,NSIG)        
COMM  
COMM  ........//// on forme le vecteur de chargement ///...............
COMM            
      CALL CAFORC(DFOR,F,ICO)
COMM
COMM  ...//// ecriture de l'entete dans le fichier de sortie ////..........
COMM                        
c      OPEN(30,FILE=NOMFICH,STATUS='UNKNOWN',ACCESS='SEQUENTIAL')
c      WRITE(30,*) ' Nombre de Noeuds et de d.d.l par noeuds '
c      WRITE(30,*) NNOE,NDPN            
COMM
COMM  ...////  Continuation Asymptotique-Numerique ///......................
COMM          
      APOSITIF=.TRUE.
c      READ(5,*) NP   nombre de pas
c      READ(5,*) XL   normalisation de a
c      READ(5,*) CRIT,NPOI   critre, nombre de points par pas
      NP= 3
      XL= 1.
      CRIT=1.0
      NPOI= 6
      
      DO 15 IP=1,NP
C
       CALL SERIES(COOR,MAIL,EMAI,EPAI,LIAI,
     *             IDIA,F,RIG,C0,U0,SIG0,
     *             Ci,Ui,SIGi,Ti,FQi,XL,
     *             NNOE,NMAI,NDL,NCPN,NDPN,NNPE,NLIAI,
     *             NVMA,KTYP,NSPG,NTPG,NSIG,NTET,NORDRE,ICO)      
C
       DO 44 IFNL=2,NORDRE+1
         CALL CALIMP(LIAI,FQi(1+NDL*(IFNL-1)),NLIAI,NDPN)
         FNLNORM(IFNL)=NORME1( FQi(1+NDL*(IFNL-1)),NDL)
         WRITE(6,43) IFNL,FNLNORM(IFNL)
 44    CONTINUE
 43    FORMAT( 'Norme du vecteur Fnl(',I2,')=',G15.8)
C 
        CALL DETRAY(CRIT,Ui,FQi,RAYON,NDL,NORDRE)                   
C
         CALL SENSCO(Ui,Utra,IP,APOSITIF,RAYON,NPOI,DA,NDL)
         DO 4 IPOI=1,NPOI
          A=DA*IPOI         
          CALL SOLPOL(C0,U0,SIG0,
     *                Ci,Ui,SIGi,
     *                LAMBDA   ,Utra,Stra,
     *                NDL,NSIG,NORDRE,A)
          WRITE(6,*) ' Parametre de charge '
          WRITE(6,*) LAMBDA,A,A,A
          CALL ECDEPL(Utra,6,ICO)                      
 4       CONTINUE                  
         CALL DINCRE(F,Ftra,NDL,LAMBDA)
         CALL RESIDU(Utra,COOR,MAIL,EMAI,EPAI,
     *               SIG0,RES,Ftra,
     *               NMAI,NDL,NCPN,NDPN,NNPE,NVMA,KTYP)
         CALL CALIMP(LIAI,RES,NLIAI,NDPN)     
         CALL NORMER(RES,Ftra,IP,NDL,XNORM1R)
C               
         CALL SHIFTD(LAMBDA,C0,1)
         CALL SHIFTD(Utra,U0,NDL)
         CALL SHIFTD(Stra,SIG0,NSIG)
C
         CALL VORIEN(Ui,Utra,APOSITIF,NORDRE,NDL,RAYON)                            

 15   CONTINUE

COMM ..................../////////////................................
 150  FORMAT(////////,
     ;'  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%',/,
     ;'  %                                                        %',/, 
     ;'  %         CALCUL   ASYMPTOTIQUE  NUMERIQUE               %',/,      
     ;'  %                                                        %',/,      
     ;'  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')           
      END
      
      SUBROUTINE SERIES(COOR,MAIL,EMAI,EPAI,LIAI,
     *                  IDIA,F,RIG,C0,V0,SIG0,C,V,SIG,TET,FQ,XL,
     *                  NNOE,NMAI,NDL,NCPN,NDPN,NNPE,NLIAI,NVMA,
     *                  KTYP,NSPG,NTPG,NSIG,NTET,NORDRE,ICO)      
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                %
COMM %   ON RESOUT LES PROBLEMES A CHAQUE ORDRE POUR DETERMINER       %
COMM %   LES TERMES   C(p)  V(p)   SIG(p)   T(p)                      %
COMM %                                                                %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)      
      DIMENSION COOR(NCPN,1),MAIL(NNPE+2,1),EMAI(NVMA,1),EPAI(1),
     *          LIAI(2,1),IDIA(1),F(1),RIG(1),V0(1),SIG0(1),
     *          C(1),V(NDL,*),SIG(NSIG,*),TET(NTET,*),FQ(NDL,*)              
COMM  ..................///////////////////............................
COMM    - on initialise C(p)  V(p)  SIG(p)   T(p)   a zero
COMM    - on calcule la matrice de rigidite tangente a partir de V(0)
COMM    - on tient compte des liaisons
COMM    - on decompose la matrice une fois pour toute 
COMM       XL    = norme du pas tangent
COMM  ..................///////////////////............................
COMM 
      CALL DZERO(C  , NORDRE+1)
      CALL DZERO(V  ,(NORDRE+1)*NDL)
      CALL DZERO(SIG,(NORDRE+1)*NSIG)
      CALL DZERO(TET,(NORDRE+1)*NTET)
      CALL RIGTAN(RIG,IDIA,COOR,MAIL,EMAI,EPAI,V0,SIG0,
     *            NMAI,NDL,NCPN,NDPN,NNPE,NSPG,NVMA,KTYP)
      CALL CALIRI(RIG,IDIA,LIAI,NLIAI,NDPN,NDL)
      CALL DECCHO(RIG,IDIA,NDL,0) 
COMM  ............//////  PAS TANGENT   /////////.......................
COMM    - on resoud  K U* = F
COMM    - on defini C(1) V(1) a l'aide du U* et de XL
COMM  ..................///////////////////............................
      CALL SHIFTD(F,V(1,1),NDL)
      CALL CALIMP(LIAI,V(1,1),NLIAI,NDPN)
      CALL RESCHO(RIG,V(1,1),IDIA,NDL)            
      CALL CVORD1(C,V,XL,NDL)
COMM  ....//// Cn Vn SIGn et Tn A CHAQUE ORDRE , ON LES IMPRIME  ////....
COMM     - on forme le second membre FQ  relatif a l'operateur Q 
COMM     - on resout Kt U = FQ
COMM     - on calcule le coefficient C(p) (depend du choix de "a")
COMM       et on termine de former le vecteur Vn
COMM  ..................///////////////////............................
      DO 2 IORDRE=2,NORDRE+1
C
      CALL SMENFQ(FQ(1,IORDRE),V0,V,SIG,TET,COOR,MAIL,EMAI,EPAI,KTYP,
     *     NMAI,NDL,NSIG,NTET,NNPE,NCPN,NDPN,NSPG,NTPG,NVMA,IORDRE)
      CALL SHIFTD(FQ(1,IORDRE),V(1,IORDRE),NDL)
      CALL CALIMP(LIAI,V(1,IORDRE),NLIAI,NDPN)
      CALL RESCHO(RIG,V(1,IORDRE),IDIA,NDL)
      CALL CVORDP(C,V,XL,NDL,IORDRE)  
      CALL IMPCVP(C,V,NDL,IORDRE-1,ICO)
C
 2    CONTINUE       
      END
      
      SUBROUTINE DETRAY(CRIT,V,FQ,RAYON,NDL,NORDRE) 
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %   ON DETERMINE LE RAYON DE CONVERGENCE DE LA SERIE              %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DIMENSION V(NDL,*),FQ(NDL,*)
C
C-----calcul de am sur la base du   (Un - Un-1)/U1 < eps
C 
      XNOR1=DSQRT(PROSCA(V(1,1),V(1,1),NDL))
      XNORP=DSQRT(PROSCA(V(1,NORDRE),V(1,NORDRE),NDL))
      RAYDEP=(CRIT*(XNOR1/XNORP))**(1.D0/DBLE(NORDRE-1))
C
C----calcul du rayon sur la base du residu   R= a**n+1 Fn+1
C
      XNF=DSQRT(PROSCA(FQ(1,NORDRE+1),FQ(1,NORDRE+1),NDL))
      RAYRES  =(CRIT/XNF)**(1.D0/DBLE(NORDRE+1))
C
      WRITE(6,50) XNOR1,XNORP,RAYDEP
      WRITE(6,60) CRIT,XNF,RAYRES
C
      RAYON=RAYRES  
 50   FORMAT(//,' Rayon de convergence : Critere deplacement',//,
     *'Norme de   V(1)   =',G15.8,
     *'Norme de V(nordre)=',G15.8,
     *' Rayon dep = ',G15.8,//)
 60   FORMAT(//,' Rayon de convergence : Critere residu',//,
     *'residu maxi          =',G15.8,
     *'Norme de Fq(nordre+1)=',G15.8,
     *' Rayon res = ',G15.8,//)        
      END

      SUBROUTINE SENSCO(V,U,IP,APOSITIF,RAYON,NPOI,DA,NDL)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %   ON DETERMINE LE SENS DE PARCOURT ET LE PAS                    %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL APOSITIF 
      DIMENSION V(NDL,1),U(1)
      IF(IP.EQ.1) THEN
       APOSITIF=.TRUE.
       DA=RAYON/DBLE(NPOI)          
      ELSE      
        PROJ=PROSCA(V(1,1),U,NDL)
        IF(PROJ.GT.0) THEN
         APOSITIF=.TRUE.
         DA=RAYON/DBLE(NPOI)       
        ELSE
         APOSITIF=.FALSE.
         DA=-RAYON/DBLE(NPOI)
        ENDIF
      ENDIF
      END
      
      SUBROUTINE VORIEN(V,U,APOSITIF,NOR,NDL,RAYON)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %   ON FORME UN VECTEUR ORIENTE DANS LE SENS DU PARCOURS          %
COMM %   A L'AIDE DE dV/dA EN FIN DE PAS (A=RAYON)                     %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      LOGICAL APOSITIF 
      DIMENSION V(NDL,1),U(1)
C
       IF(APOSITIF) THEN
        A=RAYON
       ELSE
        A=-RAYON
       ENDIF
       DO 5 K=1,NDL
 5     U(K)=V(K,1)
       DO 3  J=2,NOR 
        PA=1.D0
        DO 32 JJ=1,J-1
 32     PA=PA*A
        PA=PA*J
        DO 31 K=1,NDL
 31     U(K)=U(K)+V(K,J)*PA
 3     CONTINUE 
       IF(APOSITIF) THEN
       ELSE
       DO 6 K=1,NDL
 6     U(K)=-U(K)
       ENDIF
      END 
      
      SUBROUTINE SOLPOL(C0,V0,SIG0,C,V,SIG,LAMBDA,U,S,
     *                  NDL,NSIG,NOR,A)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 %
COMM %   ON FORME LA SOLUTIONS POLYNOMIALES --> Lambda,U,S             %
COMM %                                                                 %
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      DOUBLE PRECISION LAMBDA  
      DIMENSION V0(1),SIG0(1),C(1),V(NDL,1),SIG(NSIG,1),U(1),S(1)
C
       LAMBDA=C0
       DO 5 K=1,NDL
 5     U(K)=V0(K)
       DO 6 K=1,NSIG
 6     S(K)=SIG0(K) 
C
       DO 3  J=1,NOR 
        PA=1.D0
        DO 32 JJ=1,J
 32     PA=PA*A
        LAMBDA=LAMBDA+C(J)*PA
        DO 31 K=1,NDL
 31     U(K)=U(K)+V(K,J)*PA
        DO 33 K=1,NSIG
 33     S(K)=S(K)+SIG(K,J)*PA  
 3     CONTINUE 
      END
     
                  
      SUBROUTINE IMPCVP(C,V,NDL,IOR,ICO)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 % 
COMM %  ON IMPRIME LE COEFFICIENT  C(IOR) ET LE VECTEUR V(IOR)         %
COMM %                                                                 %    
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION C(1),V(NDL,1),ICO(50)
C 
      WRITE(6,100) IOR,IOR,C(IOR),C(IOR)
      CALL ECDEPL(V(1,IOR),6,ICO)
 100  FORMAT ( ' ORDRE ',I2,' :   C(',I2,')=',G15.8,/,G15.8)

      END      
      
      SUBROUTINE CVORD1(C,V,XL,NDL)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 % 
COMM %  ON CALCULE LE COEFFICIENT  C(1) ET LE VECTEUR V(1)             %
COMM %                                                                 %    
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION C(1),V(NDL,1)
COMM 
      C(1)=DSQRT((XL*XL)/(PROSCA(V(1,1),V(1,1),NDL))) 
C      C(1)=1.D0
      DO 1 I=1,NDL
 1    V(I,1)=V(I,1)*C(1)
      END
       
      SUBROUTINE CVORDP(C,V,XL,NDL,IORDRE)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 % 
COMM %  ON CALCULE LE COEFFICIENT  C(p) ET ON TERMINE LE VECTEUR V(p)  %
COMM %                                                                 %    
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION C(1),V(NDL,1)
COMM
COMM ....//// a={u,v1} +  l*C(1) /{v1,v1} + C(1)*C(1) /////..............
COMM
      C(IORDRE)=-PROSCA(V(1,IORDRE),V(1,1),NDL)*C(1)/(XL*XL)
C      C(IORDRE)=0.D0
COMM  
COMM ..../////   calcul de V(p) //////...................................
COMM
      COEF=C(IORDRE)/C(1)
      DO 20 I=1,NDL
 20   V(I,IORDRE)=V(I,IORDRE)+V(I,1)*COEF
      END 
       
      DOUBLE PRECISION FUNCTION NORME1(F,N)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 % 
COMM %  ON CALCULE LA NORME  DE F (vecteur de taille N )               %
COMM %                                                                 %    
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
      DOUBLE PRECISION F(1) 
      NORME1=0.D0
      DO 1 I=1,N
 1    IF(DABS(F(I)).GT.NORME1) NORME1=DABS(F(I))
      END
          
      SUBROUTINE NORMER(RES,F,IP,NDL,XNORM1R)
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
COMM %                                                                 % 
COMM %  ON CALCULE LES NORMES  DU RESIDU ET DE F                       %
COMM %                                                                 %    
COMM %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION RES(1),F(1)
COMM 
      XNORM1R=0.D0
      DO 1 I=1,NDL
 1    IF(DABS(RES(I)).GT.XNORM1R) XNORM1R=DABS(RES(I))
      XNORM1F=0.D0
      DO 2 I=1,NDL
 2    IF(DABS(F(I)).GT.XNORM1F) XNORM1F=DABS(F(I))      
      XNORM2R=SQRT(PROSCA(RES,RES,NDL))
      XNORM2F=SQRT(PROSCA(F,F,NDL))
      RATIO1=XNORM1R/XNORM1F
      RATIO2=XNORM2R/XNORM2F                
      WRITE(6,100) IP,XNORM1R,XNORM1F,RATIO1,XNORM2R,XNORM2F,RATIO2
COMM
 100  FORMAT( //,' Qualite de la solution au point numero ',I5,//,
     *        ' Plus grande composante du vecteur RESIDU :',G15.8,/,
     *        ' Plus grande composante du vecteur FORCE  :',G15.8,/,
     *        ' Ratio des plus grandes composantes       :',G15.8,///,
     *        ' Norme euclidienne du vecteur RESIDU :',G15.8,/,
     *        ' Norme euclidienne du vecteur FORCE  :',G15.8,/,
     *        ' Ratio des normes euclidiennes       :',G15.8,///)    

      END 
